﻿(function (app) {
    app.controller('goodsCtrl', ["$scope", "$state", 'goodsService', '$ionicSideMenuDelegate', 'msg', function ($scope, $state, goodsService, $ionicSideMenuDelegate, msg) {

        $scope.filter = {
            hasMore: false,
            pageIndex: 0,
            pageSize: 10,
            type:1,
            begin_address: '',
            end_address: '',
            midway_address:''
        }
        $scope.items = [];
        $scope.load = function (init) {
            if (init) {
                $scope.filter.pageIndex = 1;
                $scope.items = [];
            }
            goodsService.listGoods($scope.filter).then(function (result) {
                 
                $scope.filter.pageIndex++;
                var more = (result.data.data.length >= $scope.filter.pageSize);
                $scope.filter.hasMore = more;
                $scope.items = $scope.items.concat(result.data.data);
                if (init) {
                    $scope.$broadcast('scroll.refreshComplete');
                } else {
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                }
            }, function (erro) {
                msg.error(erro.data.message);
            });
        }
        $scope.toggleRight = function () {
            $scope.load(true);
            $ionicSideMenuDelegate.toggleRight();
        };
        $scope.detail = function (item) {
            $state.go('wl.goods_detail', {item:item})
        }
        $scope.add = function () {
            $state.go('wl.goods_add');
        }
        $scope.goCar = function () {
            $state.go('wl.car');
        }
        $scope.load(true);
        $scope.getLocation = function () {
            //http://lbs.amap.com/api/javascript-api/reference/plugin/#m_AMap.Geolocation
           var mapObj = new AMap.Map('iCenter');
            mapObj.plugin('AMap.Geolocation', function () {
                geolocation = new AMap.Geolocation({
                    enableHighAccuracy: true,//是否使用高精度定位，默认:true
                    timeout: 10000,          //超过10秒后停止定位，默认：无穷大
                    maximumAge: 0,           //定位结果缓存0毫秒，默认：0
                    convert: true,           //自动偏移坐标，偏移后的坐标为高德坐标，默认：true
                    showButton: true,        //显示定位按钮，默认：true
                    buttonPosition: 'LB',    //定位按钮停靠位置，默认：'LB'，左下角
                    buttonOffset: new AMap.Pixel(10, 20),//定位按钮与设置的停靠位置的偏移量，默认：Pixel(10, 20)
                    showMarker: true,        //定位成功后在定位到的位置显示点标记，默认：true
                    showCircle: true,        //定位成功后用圆圈表示定位精度范围，默认：true
                    panToLocation: true,     //定位成功后将定位到的位置作为地图中心点，默认：true
                    zoomToAccuracy: true      //定位成功后调整地图视野范围使定位位置及精度范围视野内可见，默认：false
                });
                mapObj.addControl(geolocation);
                AMap.event.addListener(geolocation, 'complete', function (result) {
                    alert('sucess:' + JSON.stringify(result));
                });//返回定位信息
                AMap.event.addListener(geolocation, 'error', function (error) {
                    alert('error:' + JSON.stringify(error));
                });      //返回定位出错信息
            });
        }
      //  $scope.getLocation();
    }]);
    app.controller('goodsAddCtrl', ["$scope", "$state", "goodsService", "msg", function ($scope, $state, goodsService, msg) {

        $scope.vm = { type: 1 };
        $scope.vm.begin_addressPick = {
            areaData: ['请选择城市'],
            title: '出发地址',
            hardwareBackButtonClose: false
        }
        $scope.vm.end_addressPick = {
            areaData: ['请选择城市'],
            title: '到达地址',
            hardwareBackButtonClose: false
        }
        $scope.vm.midway_addressPick = {
            areaData: ['请选择城市'],
            title: '途经地址',
            hardwareBackButtonClose: false
        }
        $scope.save = function () {
            var price=new Number($scope.vm.price);
            if (!price) {
                msg.text('输入价格');
                return;
            }
            if ($scope.vm.begin_addressPick.areaData.length == 1) {
                msg.text('请输入出发地址');
                return;
            }
            if ($scope.vm.end_addressPick.areaData.length == 1) {
                msg.text('请输入到达地址');
                return;
            }
            if ($scope.vm.midway_addressPick.areaData.length == 1) {
                msg.text('请输入途经地址');
                return;
            }
            if (!$scope.vm.detail) {
                msg.text('请输入详情');
                return;
            }
            msg.loading('提交中...');
            $scope.vm.begin_address = $scope.vm.begin_addressPick.areaData.join(',');
            $scope.vm.end_address = $scope.vm.end_addressPick.areaData.join(',');
            $scope.vm.midway_address = $scope.vm.midway_addressPick.areaData.join(',');
            goodsService.addGoods($scope.vm).then(function (result) {
                $state.go('wl.goods');
                msg.hide();
            }, function (erro) {
                msg.hide();
                msg.error(erro.data.message);
            });
        }
    }]);
    app.controller('goodsDetailCtrl', ["$scope", '$stateParams', 'msg', 'orderService', '$state', 'userService'
        , function ($scope, $stateParams, msg, orderService, $state, userService) {
        $scope.vm = $stateParams.item;
        userService.getMapPic($scope.vm.begin_address).then(function (result) {
            $scope.vm.picUrl = result;
        });
        //下单
        $scope.bill = function () {
            msg.confirm('下单提示', '确定下单？').then(function (res) {
                if (res) {
                    msg.loading('下单中...');
                    orderService.addOrder({ message_id: $scope.vm.id }).then(function (result) {
                        msg.hide();
                        $state.go('wl.goods_success', {item:$scope.vm});
                    }, function (erro) {
                        msg.hide();
                        msg.error(erro.data.message);
                    })
                } else {

                }
            });
        }
    }]);
    app.controller('goodsSuccessCtrl', ['$scope', '$state', '$ionicHistory', '$stateParams', function ($scope, $state, $ionicHistory, $stateParams) {
        $scope.vm = $stateParams.item;
        //下单成功
        $scope.back = function () {
            $ionicHistory.clearHistory();
            $state.go('wl.goods');
        }
    }]);
})(angular.module('app.controllers'));