﻿(function (app) {
    app.controller('myCtrl', ["$scope", "$state", 'userService', 'msg', function ($scope, $state, userService,msg) {
        $scope.user = {};
        userService.getUser().then(function (result) {
            $scope.user = result.data.data;
        }, function (erro) {
            msg.error(erro.data.message);
        });
        $scope.toProfile = function () {
            $state.go('wl.my_profile');
        }
    }]);
    app.controller('mySettingCtrl', ['$scope', 'data', '$state', '$http','$ionicModal', function ($scope, data, $state, $http,$ionicModal) {
        $scope.logout = function () {
            data.remove('user');
            data.remove('token');
            $http.defaults.headers.common["Authorization"] =undefined;
            $state.go('login');
        }
        $ionicModal.fromTemplateUrl('low.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.modal1 = modal;
        });
        $ionicModal.fromTemplateUrl('compay.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.modal2 = modal;
        });
        $scope.openModal1 = function() {
            $scope.modal1.show();
        };
        $scope.closeModal1 = function() {
            $scope.modal1.hide();
        };
        $scope.openModal2 = function() {
            $scope.modal2.show();
        };
        $scope.closeModal2 = function() {
            $scope.modal2.hide();
        };
        // Cleanup the modal when we're done with it!
        $scope.$on('$destroy', function() {
            $scope.modal1.remove();
            $scope.modal2.remove();
        });
        $scope.appversion = '1.0.0';
        if (!!window.AppVersion) {
            $scope.appversion = AppVersion.version;
        }
    }]);
    app.controller('mySetPasswordCtrl', ['$scope', '$state', function ($scope,$state) {
        $scope.vm = {
            password: '',
            password2: '',
            isloading: false,

        };
        $scope.submit = function () {

        }
    }]);
    
    app.controller('myProfileCtrl', ['$scope','$ionicActionSheet','$ionicPopup','$timeout','userService', 'msg', 'util','data', function ($scope,$ionicActionSheet,$ionicPopup,$timeout, userService, msg, util,data) {
        $scope.user = data.getObject('user');
        $scope.genderOpt = [
              { name: "男", value: 1 },
              { name: "女", value: 0 }
        ];
        userService.getApplyProfile().then(function (result) {
            $scope.vm = result;
        }, function (erro) {
            msg.error(erro);
        });
        $scope.setAvator = function () {
            var sheet = $ionicActionSheet.show({
                buttons: [{ text: '<b>拍照</b> 上传' }, { text: '从 <b>相册</b> 中选' }],
                titleText: '图片上传',
                cancelText: '取 消',
                cancel: function() { return true; },
                buttonClicked: function(index) {
                    var options = { quality: 50, targetHeight: 112, targetWidth: 112, allowEdit: true};
                    if (index == 0) options.sourceType = 1;
                    else options.sourceType = 2;
                    navigator.camera.getPicture(function(imageUri) {
                        if (imageUri == undefined) {
                            var alertPopup = $ionicPopup.alert({
                               title: '提示',
                               template: '图片未找到！'
                             });
                             alertPopup.then(function(res) {
                               console.log('1111');
                             });
                        }else {
                            $timeout(function() {
                                $scope.user.avatar = imageUri;
                            });
                            var uploadOptions = new FileUploadOptions();
                            uploadOptions.fileKey = "photo";
                            uploadOptions.fileName = "avatar.jpg";
                            uploadOptions.mimeType = "image/jpeg";
                            uploadOptions.httpMethod = 'post';
                            uploadOptions.chunkedMode = true;
                            var token='Bearer ' + localStorage['token'];
                            uploadOptions.headers = { "Authorization": token };
                            console.log("setAvator uploadOptions:"+JSON.stringify(uploadOptions));
                            var ft = new FileTransfer();
                            ft.upload(imageUri, encodeURI(config.server+"api/user"), function(sucess) {
                                console.log("setAvator sucess:"+JSON.stringify(sucess));
                                // alert(JSON.stringify(sucess));
                            }, function (fail) {
                                console.log("setAvator fail:"+JSON.stringify(fail));
                                // alert(JSON.stringify(fail));
                            }, uploadOptions); 

                        }
                    }, function(err) { 
                        var alertPopup = $ionicPopup.alert({
                           title: '提示',
                           template: err
                         });
                         alertPopup.then(function(res) {
                           console.log('1111');
                         });
                    }, options);

                    return true;
                }
            });
         
            //https://cordova.apache.org/docs/en/latest/reference/cordova-plugin-camera/
            // navigator.camera.getPicture(function (imageUri) {
            //     $scope.user.avatar = imageUri;

            //     var uploadOptions = new FileUploadOptions();
            //     uploadOptions.fileKey = "avatar";
            //     uploadOptions.fileName = "avatar.jpg";
            //     uploadOptions.mimeType = "image/jpeg";
            //     uploadOptions.httpMethod = 'post';
            //     var token='Bearer ' + localStorage['token'];
            //     alert(token);
            //     uploadOptions.headers = { "Authorization": token };
            //     var ft = new FileTransfer();
            //     ft.upload(imageUri, encodeURI("http://120.25.204.211/api/user"), function(sucess) {
            //         alert(JSON.stringify(sucess));
            //     }, function (fail) {
            //         alert(JSON.stringify(fail));
            //     }, options); 
             
            // }, function (erro) {
            //     alert(erro);
            // }, options);
        }
        $scope.save = function () {
            data.updateObject('user', $scope.user);
        }
    }]);
    
    app.controller('myTruckCtrl', ['$scope', '$state', 'myService', 'msg', function ($scope, $state, myService, msg) {
        $scope.filter = {
            hasMore: false,
            page: 0,
            pageSize: 10,
        }
        $scope.items = [];
        $scope.load = function (init) {
            if (init) {
                $scope.filter.pageIndex = 1;
                $scope.items = [];
            }
            myService.listTrucks($scope.filter).then(function (result) {
                $scope.filter.pageIndex++;
                var more = (result.data.data.length >= $scope.filter.pageSize);
                $scope.filter.hasMore = more;
                $scope.items = $scope.items.concat(result.data.data);
                if (init) {
                    $scope.$broadcast('scroll.refreshComplete');
                } else {
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                }
            }, function (erro) {
                msg.error(erro.data.message);
            });
        }
        $scope.add = function () {
            $state.go('wl.my_truck_add', { item: {}});
        }
        $scope.detail = function (item) {
            $state.go('wl.my_truck_add', {item:item});
        }
        $scope.delete = function (item, $event) {
            $event.stopPropagation();
            msg.confirm('删除提示', '确定删除？').then(function (res) {
                if (res) {
                    msg.loading('删除中...');
                    myService.deleteTruck(item.id).then(function (result) {
                        msg.hide();
                        $scope.load(true);
                    }, function (erro) {
                        msg.hide();
                        msg.error(erro.data.message);
                    })
                } else {

                }
            });
        }
        $scope.load(true);
    }]);
    app.controller('myTruckAddCtrl', ['$scope', 'myService', 'msg', '$state', '$stateParams', function ($scope, myService, msg, $state, $stateParams) {
        $scope.vm = {};
        if ($stateParams.item) {
            $scope.vm = $stateParams.item;
        }
        $scope.typeOpt = [
            { name: '厢式货车', value: '厢式货车' },
            { name: '面包车', value: '面包车' },
            { name: '金杯车', value: '金杯车' },
        { name: '中巴货车', value: '中巴货车' },
        { name: '高栏车', value: '高栏车' },
        { name: '低栏车', value: '低栏车' },
        { name: '平板车', value: '平板车' },
        { name: '高低板车', value: '高低板车' },
        { name: '半挂车', value: '半挂车' },
        { name: '自卸车', value: '自卸车' },
        { name: '冷藏车', value: '冷藏车' },
        { name: '保温车', value: '保温车' },
        { name: '罐式车', value: '罐式车' },
        { name: '铁笼车', value: '铁笼车' },
        { name: '集装箱运输车', value: '集装箱运输车' },
        { name: '大件运输车', value: '大件运输车' },
        { name: '危险品车', value: '危险品车' },
        { name: '全挂车', value: '全挂车' },
        { name: '加长挂车', value: '加长挂车' },
        { name: '其他', value: '其他' }];
        $scope.save = function () {
            msg.loading('保存中...')
            myService.addTruck($scope.vm).then(function (result) {
                msg.hide();
                $state.go('wl.my_truck');
            }, function (erro) {
                msg.hide();
                msg.error(erro.data.message);
            });
        }
        //上传图片
        $scope.setPhoto = function () {

        }
     
    }]);
    app.controller('myTruckDetailCtrl', ['$scope', function ($scope) {

    }]);
    app.controller('myMessageCtrl', ['$scope', 'myService', 'msg', '$state', function ($scope, myService, msg, $state) {
        $scope.filter = {
            hasMore: false,
            page: 0,
            pageSize: 10,
        }
        $scope.items = [];
        $scope.load = function (init) {
            if (init) {
                $scope.filter.pageIndex = 1;
                $scope.items = [];
            }
            myService.listMessages($scope.filter).then(function (result) {
                $scope.filter.pageIndex++;
                var more = (result.data.data.length >= $scope.filter.pageSize);
                $scope.filter.hasMore = more;
                $scope.items = $scope.items.concat(result.data.data);
                 
                if (init) {
                    $scope.$broadcast('scroll.refreshComplete');
                } else {
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                }
            }, function (erro) {
                msg.error(erro.data.message);
            });
        }
        
        $scope.detail = function (item) {
            $state.go('wl.my_message_detail', { item: item });
        }
        $scope.load(true);
    }]);
    app.controller('myMessageDetailCtrl', ['$scope', '$stateParams', function ($scope, $stateParams) {
        $scope.vm = $stateParams.item;
        
    }]);
    app.controller('myOrderCtrl', ['$scope', 'myService', 'msg', '$state', function ($scope, myService, msg, $state) {
        $scope.filter = {
            hasMore: false,
            page: 0,
            pageSize: 10,
        }
        $scope.items = [];
        $scope.load = function (init) {
            if (init) {
                $scope.filter.pageIndex = 1;
                $scope.items = [];
            }
            myService.listOrders($scope.filter).then(function (result) {
                $scope.filter.pageIndex++;
                var more = (result.data.data.length >= $scope.filter.pageSize);
                $scope.filter.hasMore = more;
                $scope.items = $scope.items.concat(result.data.data);
                debugger;
                if (init) {
                    $scope.$broadcast('scroll.refreshComplete');
                } else {
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                }
            }, function (erro) {
                msg.error(erro.data.message);
            });
        }
        $scope.pay = function (item,$event) {
            $event.stopPropagation();
            //to do 
        }
        $scope.delete = function (item,$event) {
            $event.stopPropagation();
            msg.confirm('删除提示', '确定删除？').then(function (res) {
                if (res) {
                    msg.loading('删除中...');
                    myService.deleteOrder(item.id).then(function (result) {
                        msg.hide();
                        $scope.load(true);
                    }, function (erro) {
                        msg.hide();
                        msg.error(erro.data.message);
                    })
                } else {

                }
            });
        }
        $scope.detail = function (item) {
            $state.go('wl.my_order_detail', { item: item });
        }
        $scope.load(true);
    }]);
    app.controller('myOrderDetailCtrl', ['$scope', '$stateParams', function ($scope, $stateParams) {
        $scope.vm = $stateParams.item;
    }]);
})(angular.module('app.controllers'));